/*!
 * AngularJS Material Design
 * https://github.com/angular/material
 * @license MIT
 * v1.1.21-master-85c9f52
 */
!function(e,m,u){"use strict";m.module("material.components.menuBar",["material.core","material.components.icon","material.components.menu"]),t.$inject=["$scope","$rootScope","$element","$attrs","$mdConstant","$document","$mdUtil","$timeout"],m.module("material.components.menuBar").controller("MenuBarController",t);var d=["handleKeyDown","handleMenuHover","scheduleOpenHoveredMenu","cancelScheduledOpen"];function t(e,t,n,o,r,i,s,l){this.$element=n,this.$attrs=o,this.$mdConstant=r,this.$mdUtil=s,this.$document=i,this.$scope=e,this.$rootScope=t,this.$timeout=l;var a=this;m.forEach(d,function(e){a[e]=m.bind(a,a[e])})}function n(n,r){return{restrict:"E",require:"mdMenuBar",controller:"MenuBarController",compile:function(e,t){return t.ariaRole||e[0].setAttribute("role","menubar"),m.forEach(e[0].children,function(e){if("MD-MENU"==e.nodeName){e.hasAttribute("md-position-mode")||(e.setAttribute("md-position-mode","left bottom"),e.querySelector("button, a, md-button").setAttribute("role","menuitem"));var t=n.nodesToArray(e.querySelectorAll("md-menu-content"));m.forEach(t,function(e){e.classList.add("md-menu-bar-menu"),e.classList.add("md-dense"),e.hasAttribute("width")||e.setAttribute("width",5)})}}),e.find("md-menu-item").addClass("md-in-menu-bar"),function(e,t,n,o){t.addClass("_md"),r(e,t),o.init()}}}}function o(e,t,n){this.$element=t,this.$attrs=n,this.$scope=e}function r(d,e,c){return{controller:"MenuItemController",require:["mdMenuItem","?ngModel"],priority:e.BEFORE_NG_ARIA,compile:function(o,e){var t,n,r=e.type,i="md-in-menu-bar";if("checkbox"!==r&&"radio"!==r||!o.hasClass(i))u("role","menuitem",o[0].querySelector("md-button, button, a"));else{var s=o[0].textContent,l=m.element('<md-button type="button"></md-button>'),a='<md-icon md-svg-src="'+c.mdChecked+'"></md-icon>';l.html(s),l.attr("tabindex","0"),m.isDefined(e.mdPreventMenuClose)&&l.attr("md-prevent-menu-close",e.mdPreventMenuClose),o.html(""),o.append(m.element(a)),o.append(l),o.addClass("md-indent").removeClass(i),u("role","checkbox"===r?"menuitemcheckbox":"menuitemradio",l),t="ng-disabled",n=d.prefixer(t),m.forEach(n,function(e){if(o[0].hasAttribute(e)){var t=o[0].getAttribute(e);l[0].setAttribute(e,t),o[0].removeAttribute(e)}})}return function(e,t,n,o){var r=o[0],i=o[1];r.init(i)};function u(e,t,n){(n=n||o)instanceof m.element&&(n=n[0]),n.hasAttribute(e)||n.setAttribute(e,t)}}}}t.prototype.init=function(){var s=this.$element,l=this.$mdUtil,e=this.$scope,a=this,t=[];s.on("keydown",this.handleKeyDown),this.parentToolbar=l.getClosest(s,"MD-TOOLBAR"),t.push(this.$rootScope.$on("$mdMenuOpen",function(e,t){-1!=a.getMenus().indexOf(t[0])&&(s[0].classList.add("md-open"),t[0].classList.add("md-open"),a.currentlyOpenMenu=t.controller("mdMenu"),a.currentlyOpenMenu.registerContainerProxy(a.handleKeyDown),a.enableOpenOnHover())})),t.push(this.$rootScope.$on("$mdMenuClose",function(e,t,n){var o=a.getMenus();-1!=o.indexOf(t[0])&&(s[0].classList.remove("md-open"),t[0].classList.remove("md-open"));var r=m.element(t[0]).controller("mdMenu");if(r.isInMenuBar&&r.mdMenuBarCtrl===a){for(var i=t[0];i&&-1==o.indexOf(i);)i=l.getClosest(i,"MD-MENU",!0);i&&(n.skipFocus||i.querySelector("button:not([disabled])").focus(),a.currentlyOpenMenu=u),a.disableOpenOnHover(),a.setKeyboardMode(!0)}})),e.$on("$destroy",function(){for(a.disableOpenOnHover();t.length;)t.shift()()}),this.setKeyboardMode(!0)},t.prototype.setKeyboardMode=function(e){e?this.$element[0].classList.add("md-keyboard-mode"):this.$element[0].classList.remove("md-keyboard-mode")},t.prototype.enableOpenOnHover=function(){if(!this.openOnHoverEnabled){var e=this;e.openOnHoverEnabled=!0,e.parentToolbar&&(e.parentToolbar.classList.add("md-has-open-menu"),e.$mdUtil.nextTick(function(){m.element(e.parentToolbar).on("click",e.handleParentClick)},!1)),m.element(e.getMenus()).on("mouseenter",e.handleMenuHover)}},t.prototype.handleMenuHover=function(e){this.setKeyboardMode(!1),this.openOnHoverEnabled&&this.scheduleOpenHoveredMenu(e)},t.prototype.disableOpenOnHover=function(){this.openOnHoverEnabled&&(this.openOnHoverEnabled=!1,this.parentToolbar&&(this.parentToolbar.classList.remove("md-has-open-menu"),m.element(this.parentToolbar).off("click",this.handleParentClick)),m.element(this.getMenus()).off("mouseenter",this.handleMenuHover))},t.prototype.scheduleOpenHoveredMenu=function(e){var t=m.element(e.currentTarget).controller("mdMenu");this.setKeyboardMode(!1),this.scheduleOpenMenu(t)},t.prototype.scheduleOpenMenu=function(e){var t=this,n=this.$timeout;e!=t.currentlyOpenMenu&&(n.cancel(t.pendingMenuOpen),t.pendingMenuOpen=n(function(){t.pendingMenuOpen=u,t.currentlyOpenMenu&&t.currentlyOpenMenu.close(!0,{closeAll:!0}),e.open()},200,!1))},t.prototype.handleKeyDown=function(e){var t,n,o,r=this.$mdConstant.KEY_CODE,i=this.currentlyOpenMenu,s=i&&i.isOpen;switch(this.setKeyboardMode(!0),e.keyCode){case r.DOWN_ARROW:i?i.focusMenuContainer():this.openFocusedMenu(),t=!0;break;case r.UP_ARROW:i&&i.close(),t=!0;break;case r.LEFT_ARROW:n=this.focusMenu(-1),s&&(o=m.element(n).controller("mdMenu"),this.scheduleOpenMenu(o)),t=!0;break;case r.RIGHT_ARROW:n=this.focusMenu(1),s&&(o=m.element(n).controller("mdMenu"),this.scheduleOpenMenu(o)),t=!0}t&&(e&&e.preventDefault&&e.preventDefault(),e&&e.stopImmediatePropagation&&e.stopImmediatePropagation())},t.prototype.focusMenu=function(e){var t=this.getMenus(),n=this.getFocusedMenuIndex();-1==n&&(n=this.getOpenMenuIndex());var o=!1;if(-1==n?o=!(n=0):(e<0&&0<n||0<e&&n<t.length-e)&&(n+=e,o=!0),o)return t[n].querySelector("button").focus(),t[n]},t.prototype.openFocusedMenu=function(){var e=this.getFocusedMenu();e&&m.element(e).controller("mdMenu").open()},t.prototype.getMenus=function(){var e=this.$element;return this.$mdUtil.nodesToArray(e[0].children).filter(function(e){return"MD-MENU"==e.nodeName})},t.prototype.getFocusedMenu=function(){return this.getMenus()[this.getFocusedMenuIndex()]},t.prototype.getFocusedMenuIndex=function(){var e=this.$mdUtil.getClosest(this.$document[0].activeElement,"MD-MENU");return e?this.getMenus().indexOf(e):-1},t.prototype.getOpenMenuIndex=function(){for(var e=this.getMenus(),t=0;t<e.length;++t)if(e[t].classList.contains("md-open"))return t;return-1},t.prototype.handleParentClick=function(e){var t=this.querySelector("md-menu.md-open");t&&!t.contains(e.target)&&m.element(t).controller("mdMenu").close(!0,{closeAll:!0})},n.$inject=["$mdUtil","$mdTheming"],m.module("material.components.menuBar").directive("mdMenuBar",n),m.module("material.components.menuBar").directive("mdMenuDivider",function(){return{restrict:"E",compile:function(e,t){t.role||e[0].setAttribute("role","separator")}}}),o.$inject=["$scope","$element","$attrs"],m.module("material.components.menuBar").controller("MenuItemController",o),o.prototype.init=function(e){var t=this.$element,n=this.$attrs;this.ngModel=e,"checkbox"!=n.type&&"radio"!=n.type||(this.mode=n.type,this.iconEl=t[0].children[0],this.buttonEl=t[0].children[1],e&&this.initClickListeners())},o.prototype.clearNgAria=function(){var t=this.$element[0];m.forEach(["role","tabindex","aria-invalid","aria-checked"],function(e){t.removeAttribute(e)})},o.prototype.initClickListeners=function(){var e=this,t=this.ngModel,n=this.$scope,o=this.$attrs,r=(this.$element,this.mode);this.handleClick=m.bind(this,this.handleClick);var i=this.iconEl,s=m.element(this.buttonEl),l=this.handleClick;function a(e){e?s.off("click",l):s.on("click",l)}o.$observe("disabled",a),a(o.disabled),t.$render=function(){e.clearNgAria(),!function(){{if("radio"!=r)return t.$modelValue;var e=o.ngValue?n.$eval(o.ngValue):o.value;return t.$modelValue==e}}()?(i.style.display="none",s.attr("aria-checked","false")):(i.style.display="",s.attr("aria-checked","true"))},n.$$postDigest(t.$render)},o.prototype.handleClick=function(e){var t,n=this.mode,o=this.ngModel,r=this.$attrs;"checkbox"==n?t=!o.$modelValue:"radio"==n&&(t=r.ngValue?this.$scope.$eval(r.ngValue):r.value),o.$setViewValue(t),o.$render()},r.$inject=["$mdUtil","$mdConstant","$$mdSvgRegistry"],m.module("material.components.menuBar").directive("mdMenuItem",r)}(window,window.angular);